%global pkg_name xmonad-contrib

%bcond_without doc
%bcond_without prof

# ghc does not emit debug information
%global debug_package %{nil}

Name:           ghc-%{pkg_name}
Version:        0.8.1
Release:        8%{?dist}
Summary:        Third party extensions for xmonad

Group:          Development/Libraries
License:        BSD3
URL:            http://hackage.haskell.org/cgi-bin/hackage-scripts/package/%{pkg_name}
Source0:        http://hackage.haskell.org/packages/archive/%{pkg_name}/%{version}/%{pkg_name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# fedora ghc archs:
ExclusiveArch:  %{ix86} x86_64 ppc alpha
BuildRequires:  ghc-xmonad-devel = %{version}
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-X11-xft-devel
BuildRequires:  ghc, ghc-rpm-macros
%if %{with doc}
BuildRequires:  ghc-doc
BuildRequires:  ghc-utf8-string-doc
BuildRequires:  ghc-X11-xft-doc
%endif
%if %{with prof}
BuildRequires:  ghc-prof
BuildRequires:  ghc-xmonad-prof = %{version}
BuildRequires:  ghc-utf8-string-prof
BuildRequires:  ghc-X11-xft-prof
%endif

%description
Haskell %{pkg_name} library for ghc-%{ghc_version}.

Third party tiling algorithms, configurations and scripts to xmonad,
a tiling window manager for X.

For an introduction to building, configuring and using xmonad
extensions, see "XMonad.Doc". In particular:

"XMonad.Doc.Configuring", a guide to configuring xmonad

"XMonad.Doc.Extending", using the contributed extensions library

"XMonad.Doc.Developing", introduction to xmonad internals and writing
your own extensions.

%package devel
Summary:        Haskell %{pkg_name} library
Group:          Development/Libraries
Requires:       ghc = %{ghc_version}
Requires(post): ghc = %{ghc_version}
Requires(preun): ghc = %{ghc_version}
Requires:       ghc-xmonad-devel
Requires:       ghc-utf8-string-devel
Requires:       ghc-X11-xft-devel

%description devel
This package contains the development files for %{name}
built for ghc-%{ghc_version}.


%if %{with doc}
%package doc
Summary:        Documentation for %{name}
Group:          Development/Libraries
Requires:       ghc-doc = %{ghc_version}
Requires(post): ghc-doc = %{ghc_version}
Requires(postun): ghc-doc = %{ghc_version}
Requires:       ghc-xmonad-doc
Requires:       ghc-utf8-string-doc
Requires:       ghc-X11-xft-doc
BuildRequires:  ghc-xmonad-doc

%description doc
This package contains development documentation files for the %{name} library.
%endif


%if %{with prof}
%package prof
Summary:        Profiling libraries for %{name}
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}-%{release}
Requires:       ghc-prof = %{ghc_version}
Requires:       ghc-xmonad-prof
Requires:       ghc-utf8-string-prof
Requires:       ghc-X11-xft-prof

%description prof
This package contains profiling libraries for %{name}
built for ghc-%{ghc_version}.
%endif


%prep
%setup -q -n %{pkg_name}-%{version}


%build
%cabal_configure --ghc %{?with_prof:-p}
%cabal build
%if %{with doc}
%cabal haddock
%endif
%ghc_gen_scripts


%install
rm -rf $RPM_BUILD_ROOT
%cabal_install
%ghc_install_scripts
%ghc_gen_filelists %{name}


%clean
rm -rf $RPM_BUILD_ROOT


%post devel
%ghc_register_pkg


%if %{with doc}
%post doc
%ghc_reindex_haddock
%endif


%preun devel
if [ "$1" -eq 0 ] ; then
  %ghc_unregister_pkg
fi


%if %{with doc}
%postun doc
if [ "$1" -eq 0 ] ; then
  %ghc_reindex_haddock
fi
%endif


%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}


%if %{with doc}
%files doc -f %{name}-doc.files
%defattr(-,root,root,-)
%endif


%if %{with prof}
%files prof -f %{name}-prof.files
%defattr(-,root,root,-)
%endif


%changelog
* Fri Aug 28 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-8
- added a few more docs

* Thu Aug 27 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-7
- removed bcond since xft will be in fedora soon

* Wed Aug 26 2009 Jens Petersen <petersen@redhat.com> - 0.8.1-6
- drop ghc-X11 deps since already in xmonad
- drop X lib deps since already in ghc-X11
- add ghc-utf8-string deps
- add bcond for X11-xft
- drop base package requires

* Wed Jun 17 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-5
- added -devel to some BRs

* Wed Jun 17 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-4
- updated to latest cabal2spec 0.16

* Mon Mar  2 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-3
- updated to new guidelines ala cabal2spec 0.12

* Tue Feb 24 2009 Yaakov M. Nemoy <ynemoy@fedoraproject.org> - 0.8.1-2
- updated package to new guidelines ala cabal2spec 0.7

* Wed Jan 21 2009 ynemoy <ynemoy@fedoraproject.org> - 0.8.1-1
- initial packaging for Fedora created by cabal2spec
